"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("@testing-library/react");
var user_event_1 = __importDefault(require("@testing-library/user-event"));
var react_2 = __importDefault(require("react"));
var KitchenSink_1 = require("./KitchenSink");
describe("useForm", function () {
    beforeEach(function () {
        jest.useFakeTimers();
    });
    afterEach(function () {
        jest.runOnlyPendingTimers();
        jest.useRealTimers();
    });
    it("should render without errors", function () {
        react_1.render(react_2.default.createElement(KitchenSink_1.KitchenSink, null));
        expect(react_1.screen.getByTestId(KitchenSink_1.testIds.errorText)).toHaveTextContent("");
    });
    it("no errors for entering in '1'", function () { return __awaiter(void 0, void 0, void 0, function () {
        var domNode;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    react_1.render(react_2.default.createElement(KitchenSink_1.KitchenSink, null));
                    domNode = react_1.screen.getByLabelText("Field");
                    user_event_1.default.type(domNode, "1");
                    expect(domNode.value).toEqual("1");
                    expect(react_1.screen.getByTestId(KitchenSink_1.testIds.errorText)).toHaveTextContent("");
                    // Check wait for loading
                    expect(react_1.screen.queryByText(/Valid!/)).not.toBeTruthy();
                    user_event_1.default.click(react_1.screen.getByText("Submit"));
                    expect(react_1.screen.queryByText(/Valid!/)).not.toBeTruthy();
                    return [4 /*yield*/, react_1.act(function () { return __awaiter(void 0, void 0, void 0, function () { return __generator(this, function (_a) {
                            return [2 /*return*/, jest.runAllTimers()];
                        }); }); })];
                case 1:
                    _a.sent();
                    user_event_1.default.click(react_1.screen.getByText("Submit"));
                    expect(react_1.screen.getByText(/Valid!/)).toBeTruthy();
                    return [2 /*return*/];
            }
        });
    }); });
    it("should error after entering and removing a character because required", function () { return __awaiter(void 0, void 0, void 0, function () {
        var domNode;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    react_1.render(react_2.default.createElement(KitchenSink_1.KitchenSink, null));
                    domNode = react_1.screen.getByLabelText("Field");
                    user_event_1.default.type(domNode, "1");
                    expect(domNode.value).toEqual("1");
                    user_event_1.default.type(domNode, "{backspace}");
                    expect(domNode.value).toEqual("");
                    expect(react_1.screen.getByTestId(KitchenSink_1.testIds.errorText)).toHaveTextContent("Yo, Field is required");
                    expect(react_1.screen.queryByText(/Valid!/)).not.toBeTruthy();
                    user_event_1.default.click(react_1.screen.getByText("Submit"));
                    expect(react_1.screen.queryByText(/Valid!/)).not.toBeTruthy();
                    return [4 /*yield*/, react_1.act(function () { return __awaiter(void 0, void 0, void 0, function () { return __generator(this, function (_a) {
                            return [2 /*return*/, jest.runAllTimers()];
                        }); }); })];
                case 1:
                    _a.sent();
                    user_event_1.default.click(react_1.screen.getByText("Submit"));
                    expect(react_1.screen.queryByText(/Valid!/)).not.toBeTruthy();
                    return [2 /*return*/];
            }
        });
    }); });
    it("should show a custom error when entering '3'", function () { return __awaiter(void 0, void 0, void 0, function () {
        var domNode;
        return __generator(this, function (_a) {
            react_1.render(react_2.default.createElement(KitchenSink_1.KitchenSink, null));
            domNode = react_1.screen.getByLabelText("Field");
            user_event_1.default.type(domNode, "3");
            expect(domNode.value).toEqual("3");
            expect(react_1.screen.getByTestId(KitchenSink_1.testIds.errorText)).toHaveTextContent("3 is not allowed!");
            expect(react_1.screen.queryByText(/Valid!/)).not.toBeTruthy();
            user_event_1.default.click(react_1.screen.getByText("Submit"));
            expect(react_1.screen.queryByText(/Valid!/)).not.toBeTruthy();
            return [2 /*return*/];
        });
    }); });
    describe("async", function () {
        it("should show an async custom error when entering '4'", function () { return __awaiter(void 0, void 0, void 0, function () {
            var domNode;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        react_1.render(react_2.default.createElement(KitchenSink_1.KitchenSink, null));
                        domNode = react_1.screen.getByLabelText("Field");
                        user_event_1.default.type(domNode, "4");
                        expect(domNode.value).toEqual("4");
                        expect(react_1.screen.getByTestId(KitchenSink_1.testIds.errorText)).toHaveTextContent("");
                        expect(react_1.screen.getByTestId(KitchenSink_1.testIds.loading)).toHaveTextContent("...loading");
                        expect(react_1.screen.queryByText(/Valid!/)).not.toBeTruthy();
                        user_event_1.default.click(react_1.screen.getByText("Submit"));
                        expect(react_1.screen.queryByText(/Valid!/)).not.toBeTruthy();
                        return [4 /*yield*/, react_1.act(function () { return __awaiter(void 0, void 0, void 0, function () { return __generator(this, function (_a) {
                                return [2 /*return*/, jest.runAllTimers()];
                            }); }); })];
                    case 1:
                        _a.sent();
                        expect(react_1.screen.getByTestId(KitchenSink_1.testIds.errorText)).toHaveTextContent("4 is not allowed async!");
                        expect(react_1.screen.queryByTestId(KitchenSink_1.testIds.loading)).not.toBeTruthy();
                        expect(react_1.screen.queryByText(/Valid!/)).not.toBeTruthy();
                        user_event_1.default.click(react_1.screen.getByText("Submit"));
                        expect(react_1.screen.queryByText(/Valid!/)).not.toBeTruthy();
                        return [2 /*return*/];
                }
            });
        }); });
        it("should not show errors when entering '45' before the timeout", function () { return __awaiter(void 0, void 0, void 0, function () {
            var domNode;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        react_1.render(react_2.default.createElement(KitchenSink_1.KitchenSink, null));
                        domNode = react_1.screen.getByLabelText("Field");
                        user_event_1.default.type(domNode, "45");
                        expect(domNode.value).toEqual("45");
                        expect(react_1.screen.getByTestId(KitchenSink_1.testIds.errorText)).toHaveTextContent("");
                        expect(react_1.screen.getByTestId(KitchenSink_1.testIds.loading)).toHaveTextContent("...loading");
                        expect(react_1.screen.queryByText(/Valid!/)).not.toBeTruthy();
                        user_event_1.default.click(react_1.screen.getByText("Submit"));
                        expect(react_1.screen.queryByText(/Valid!/)).not.toBeTruthy();
                        return [4 /*yield*/, react_1.act(function () { return __awaiter(void 0, void 0, void 0, function () { return __generator(this, function (_a) {
                                return [2 /*return*/, jest.runAllTimers()];
                            }); }); })];
                    case 1:
                        _a.sent();
                        expect(react_1.screen.getByTestId(KitchenSink_1.testIds.errorText)).toHaveTextContent("");
                        expect(react_1.screen.queryByTestId(KitchenSink_1.testIds.loading)).not.toBeTruthy();
                        expect(react_1.screen.queryByText(/Valid!/)).not.toBeTruthy();
                        user_event_1.default.click(react_1.screen.getByText("Submit"));
                        expect(react_1.screen.getByText(/Valid!/)).toBeTruthy();
                        return [2 /*return*/];
                }
            });
        }); });
    });
});
