import { ControlledParams, CreateFormItem, LocalParams } from "./useFormTypes";
/**
 * Cases: Required (localvalidation), optional, async validation, custom validation messages
 * local state, global state
 * adaptor for custom form items
 * type check everything after "name"
 *
 * Must implement:
 * - Data type passed in, initial data
 * - create a form item
 * - onBlur for focus then unfocus for "required"
 *
 * Does not support onChange with multiple params
 */
export declare const useForm: <T extends {}>({ values, onChange, }: ControlledParams<T>) => {
    createFormItem: CreateFormItem<T>;
    validate: () => boolean;
};
export declare const useLocalForm: <T>({ initialData }: LocalParams<T>) => {
    getValues: () => T;
    createFormItem: CreateFormItem<T>;
    validate: () => boolean;
};
